package final_risk;

import java.util.ArrayList; 
import java.util.Observable;

/**
 *  <p style="margin-top: 0">
 *        Selecciona el modo de juego y habr&#225; un minimo de 2 y un maximo de 4.
 *      <br>Almacenara los territorios conquistado, numero de ejercitos etc.
 *          </p>
 */
// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.533FBE15-D365-E997-9CD2-B708CAF33C23]
// </editor-fold> 
public class Jugador extends Observable {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.150637DD-D6E2-51EC-D293-BA91AD11BD15]
    // </editor-fold> 
    private String nombre_jug;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AEEDBA9D-1DFF-3E29-B6B1-D156DE985231]
    // </editor-fold> 
    private int id_jug;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.924DBD7C-5893-0C4B-F2FD-71BA4A6332CF]
    // </editor-fold> 
    private int num_mision;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3FBCF7C9-B3AD-449A-94D2-AF0B1FBA621A]
    // </editor-fold> 
    private Boolean comodin1;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.79B78D27-266D-2CC2-B728-1EAD60869835]
    // </editor-fold> 
    private Boolean comodin2;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3C9C56F3-42B5-1D36-0683-C992C82D1681]
    // </editor-fold> 
    private int n_ejercitos;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FF9A1682-97AB-66DB-797C-FAEB9A61A2D4]
    // </editor-fold> 
    private int n_territorios;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5D916E2C-0E6D-BA59-AD75-2499B795F51F]
    // </editor-fold> 
    private ArrayList<Territorios> territorios;
   
    private boolean eliminado;

    private String terr_defender;
    
    private boolean terr_perdido;
   
    private int ejer_asignado;
    
    private Misiones_Secretas mision;
    
    private ArrayList<Territorios> cartas;
    
    private int num_cartas;


    public int getEjer_asignado() {
        return ejer_asignado;
    }

    public void setEjer_asignado(int ejer_asignado) {
        this.ejer_asignado = ejer_asignado;
    }
    
    public boolean isTerr_defe() {
        return terr_perdido;
    }

    public void setTerr_defe(boolean terr_defe) {
        this.terr_perdido = terr_defe;
    }    
        
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.81901CC1-E015-4060-8D1C-5FFB72C42F05]
    // </editor-fold> 
    public Jugador () {
        this.nombre_jug = "";
        this.id_jug= 0;
        this.territorios = null;
        this.num_mision = 0;
        this.comodin1 = false;
        this.comodin2 = false;
        this.n_ejercitos = 0;
        this.n_territorios = 0;
        this.territorios= new ArrayList(42);
        this.eliminado= false;
        this.terr_defender= "";
        this.ejer_asignado= 0;
        this.mision= null;
        this.terr_perdido= false;
        this.cartas= new ArrayList(42);
        this.num_cartas= 0;        
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.E456B848-374B-5C8F-A1A9-723B1F5C1BF2]
    // </editor-fold> 
    public void Inicializar() {
        this.nombre_jug = "";
        this.id_jug= 0;
        this.territorios = null;
        this.num_mision = 0;
        this.comodin1 = false;
        this.comodin2 = false;
        this.n_ejercitos = 0;
        this.n_territorios = 0;
        this.territorios= new ArrayList(42);
        this.eliminado= false;
        this.terr_defender= "";
        this.ejer_asignado= 0;
        this.mision= null;
        this.terr_perdido= false;
        this.cartas= new ArrayList(42);
        this.num_cartas= 0;        
    }
    
    public Misiones_Secretas getMision() {
        return mision;
    }

    public void setMision(Misiones_Secretas mision) {
        this.mision = mision;
    }
    
    
    //Devuelve el numero de territorio de un continente
    public int getTerritorioControlado_Cont (String continente) {
        int i= 0, num= 0;
        
        while (i < this.n_territorios){
            if (this.territorios.get(i).getContinente().compareTo(continente) == 0)
                num++;
            i++;
        }
        return num;
    }
    
    public boolean isEliminado() {
        return this.eliminado;
    }

    public void setEliminado(boolean eliminado) {
        this.eliminado = eliminado;
    }

    public String getTerr_defender() {
        return this.terr_defender;
    }

    public void setTerr_defender(String terr_defender) {
        this.terr_defender = terr_defender;
    }
    

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.1C3C1879-5D64-FDFA-6D21-36A461865E33]
    // </editor-fold> 
    public Boolean getComodin1 () {
        return this.comodin1;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.07FC7A07-3B9D-FB7C-CA18-99F7BA473983]
    // </editor-fold> 
    public void setComodin1 (Boolean val) {
        this.comodin1= val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.1BD9E55E-A205-59C7-17C4-0B497EAD6083]
    // </editor-fold> 
    public Boolean getComodin2 () {
        return this.comodin2;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.15AA75D3-9EFD-BA3B-B66E-A0A1F9C82547]
    // </editor-fold> 
    public void setComodin2 (Boolean val) {
        this.comodin2= val;
    }
    
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6323B562-6142-E0DE-84B9-9C47462D75C5]
    // </editor-fold> 
    public int getId_jug () {
        return this.id_jug;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FB3CDDAA-7E90-AC79-168D-943420BEBD04]
    // </editor-fold> 
    public void setId_jug (int val) {
        this.id_jug = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.51E94FD3-D295-EC05-EA86-8191EE191843]
    // </editor-fold> 
    public int getN_ejercitos () {
        return this.n_ejercitos;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C224D440-192E-CAB2-161C-30909AA8F6CA]
    // </editor-fold> 
    public void setN_ejercitos (int val) {
        this.n_ejercitos = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CF45F7DA-FCAE-8676-190D-97A0F4C78608]
    // </editor-fold> 
    public String getNombre_jug () {
        return this.nombre_jug;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2B5C399F-65A7-63FC-F8E0-C05D9DD60FE7]
    // </editor-fold> 
    public void setNombre_jug (String val) {
        this.nombre_jug = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.15F318A3-CC37-AF01-696E-721B8FFF019A]
    // </editor-fold> 
    public int getNum_mision () {
        return this.num_mision;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F12D7682-0BB7-D722-06DC-2BFB4778623C]
    // </editor-fold> 
    public void setNum_mision (int val) {
        this.num_mision= val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F183B39D-C1F5-A137-8CFE-CD5293F4029C]
    // </editor-fold> 
    public ArrayList getTerritoriosAll () {
        return this.territorios;
    }
    
    //Devuelve el territorio pasando el nombre
    public Territorios getTerritorioPorNombre (String val) {
        int i= 0, salir = 0;
        
        while (i < this.territorios.size() && salir == 0){
            if (this.territorios.get(i).getNombre().compareTo(val) != 0)
                i++;
            else
                salir= 1;
        }
        return this.territorios.get(i);
    }
    
    //Asigna ejercitos al territorio seleccionado
    public void Ubicar_Ejercitos (Territorios ter, int num_ejer) {
        int pos= -1;
        
        pos= Buscar(ter.getIdTerritorio());
        
        ter.setEjercitos(ter.getEjercitos() + num_ejer);
        
        this.setN_ejercitos(this.getN_ejercitos() - num_ejer);
        
        this.ejer_asignado= this.ejer_asignado + num_ejer;
        
        //this.territorios.add(pos, ter);
        
        setChanged();
        notifyObservers((Object)"Ubicar Ejercitos");        
    }
    
    //Devuelve el territorio pasando el identificador del territorio
    public Territorios getTerritorioPorId_Terr (int val) {
        int i= 0, salir = 0;
        
        while (i < this.territorios.size() && salir == 0){
            if (this.territorios.get(i).getIdTerritorio() != val)
                i++;
            else
                salir= 1;
        }
        return this.territorios.get(i);
    }
    
    //Devuelve el elemento que se le indique en la variable val del Arraylist
    public Territorios getTerritorios_One (int val) {
        return this.territorios.get(val);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C28C5FC3-BF76-EDBF-50C4-C53C54F83FDA]
    // </editor-fold> 
    public void AddTerritorios (Territorios val) {
        this.territorios.add(val);
    }
    
    public void quitarTerritorios (Territorios val) {
        this.territorios.remove(val);
    }
    
    public int getnumTerritorios () {
        return this.n_territorios= this.territorios.size();
    }

    public int Buscar(int idTerritorio) {
        int i= 0, salir = 0;
        
        while (i < this.territorios.size() && salir == 0){
            if (this.territorios.get(i).getIdTerritorio() != idTerritorio)
                i++;
            else
                salir= 1;
        }
        if (i > this.territorios.size())
            i= -1;
        
        return i;
    }
    
    //Devuelve true si encuentra algun territorio sin ejercitos
    public boolean NoAsignado() {
        boolean encontrado = false;
        
        for(int i=0; i<this.territorios.size() && !encontrado; i++){
            if(this.territorios.get(i).getEjercitos() == 0)
                encontrado = true;
        }
        
        return encontrado;
    }   
    
    //Asignamos un ejercito a cada uno de los territorios
    public void Ubicar_Ejercitos_Automatico() {
        
        if (this.n_territorios > this.n_ejercitos){
            setChanged();
            notifyObservers((Object)"No Automatico");        
        }
        else{
            for (int i= 0; i < this.territorios.size(); i++){
                this.territorios.get(i).setEjercitos(this.territorios.get(i).getEjercitos() + 1);
                this.setN_ejercitos(this.getN_ejercitos() - 1);
                this.setEjer_asignado(this.getEjer_asignado() + 1);
            }
            setChanged();
            notifyObservers((Object)"Automatico");        
        }
    }
    
    //Devuelve true si los territorios son vecinos y false en caso contrario.
    public boolean SiVecinos(Territorios origen,int destinoId){
        int vec [];
        boolean encontrado= false;
        
        vec= new int[origen.getNVecinos()];
        vec= origen.getVecinos();
        
        for (int i= 0; i < origen.getNVecinos() && !encontrado; i++)
            if (vec[i] == destinoId)
                encontrado= true;

        return encontrado;
    }
    
    //Traslada tantas tropas de un territorio a otro
    public void Trasladar_Tropas(Territorios origen, Territorios destino,int val){
        origen.setEjercitos(origen.getEjercitos() - val);
        destino.setEjercitos(destino.getEjercitos() + val);
        
        setChanged();
        notifyObservers((Object)"Traslado_Tropas");        
    }

    public Territorios getCartas(int cartas) {
        return this.cartas.get(cartas);
    }

    public void setCartas(Territorios cartas) {
        this.cartas.add(cartas);
    }
    

    public int getNum_cartas() {
        return this.cartas.size();
    }

    public void addNum_cartas() {
        this.num_cartas++;
        //Si el nmero de carta es 6 obligar a cambiar.
        if (this.num_cartas >= 6){
            setChanged();
            notifyObservers((Object)"Canjear Cartas");
        }    
    }
    
    public void usar_cartas(int carta){
        this.num_cartas= this.num_cartas - carta;
    }
}

