/*
 * ControladorBD.java
 *
 * Created on 19. leden 2006, 15:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package final_risk;

import javax.persistence.Persistence;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

/**
 *
 */
public class ControladorBD {

    private static EntityManagerFactory emf = Persistence.createEntityManagerFactory("Juego_Risk_FinalPU");

 
    
    /**
    * Creates a new instance of ControladorBD
    */
    private  ControladorBD() {
    }
    
    private static Collection<Ent_Jugador> createJugador() {
	Collection<Ent_Jugador> retVal = new ArrayList<Ent_Jugador>(0);
        //No hay que usarlo porque no hay que incluir a ningun jugador por defecto en la BD
		
        return retVal;
    }

    public static void add(Object object) {
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();

        try {
            // TODO:
            em.merge(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            System.out.println("Algo se ha fastidiado");
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public static void setUpDB() {
        for (Ent_Jugador p: createJugador()) {
            add(p);  //No se usara este metodo.
        }
    }
    
    public static List getData_Jugador() {
       //return emf.createEntityManager().createQuery("SELECT p FROM Jugador p").getResultList();
       return emf.createEntityManager().createQuery("SELECT p FROM Ent_Jugador p").getResultList();
    }

    public static List getData_Territorio() {
       return emf.createEntityManager().createQuery("SELECT p FROM Ent_Territorios p").getResultList();
    }
    
    public static List getData_Partida() {
       return emf.createEntityManager().createQuery("SELECT p FROM Ent_Partida p").getResultList();
    }    
}
